'use strict';

exports.__esModule = true;
exports.default = undefined;

var _class, _temp2; /**
                     * @class ReactPdfJs
                     */


var _pdfjsDist = require('pdfjs-dist');

var _pdfjsDist2 = _interopRequireDefault(_pdfjsDist);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ReactPdfJs = (_temp2 = _class = function (_Component) {
  _inherits(ReactPdfJs, _Component);

  function ReactPdfJs() {
    var _temp, _this, _ret;

    _classCallCheck(this, ReactPdfJs);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      pdf: null
    }, _this.drawPDF = function (page) {
      var _this$props = _this.props,
          scale = _this$props.scale,
          rotate = _this$props.rotate;
      // Because this page's rotation option overwrites pdf default rotation value,
      // calculating page rotation option value from pdf default and this component prop rotate.

      var rotation = rotate === 0 ? page.rotate : page.rotate + rotate;
      var viewport = page.getViewport(scale, rotation);
      var _this2 = _this,
          canvas = _this2.canvas;

      var canvasContext = canvas.getContext('2d');
      canvas.height = viewport.height;
      canvas.width = viewport.width;
      var renderContext = {
        canvasContext: canvasContext,
        viewport: viewport
      };
      page.render(renderContext);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  ReactPdfJs.prototype.componentDidMount = function componentDidMount() {
    var _this3 = this;

    var _props = this.props,
        file = _props.file,
        onDocumentComplete = _props.onDocumentComplete,
        page = _props.page,
        cMapUrl = _props.cMapUrl,
        cMapPacked = _props.cMapPacked,
        workerSrc = _props.workerSrc;

    _pdfjsDist2.default.GlobalWorkerOptions.workerSrc = workerSrc;
    _pdfjsDist2.default.getDocument({ url: file, cMapUrl: cMapUrl, cMapPacked: cMapPacked }).then(function (pdf) {
      _this3.setState({ pdf: pdf });
      if (onDocumentComplete) {
        onDocumentComplete(pdf._pdfInfo.numPages); // eslint-disable-line
      }
      pdf.getPage(page).then(function (p) {
        return _this3.drawPDF(p);
      });
    });
  };

  ReactPdfJs.prototype.componentWillReceiveProps = function componentWillReceiveProps(newProps) {
    var _this4 = this;

    var _props2 = this.props,
        page = _props2.page,
        scale = _props2.scale,
        rotate = _props2.rotate;
    var pdf = this.state.pdf;

    if (newProps.page !== page || newProps.scale !== scale || newProps.rotate !== rotate) {
      pdf.getPage(newProps.page).then(function (p) {
        return _this4.drawPDF(p);
      });
    }
  };

  ReactPdfJs.prototype.render = function render() {
    var _this5 = this;

    var className = this.props.className;

    return _react2.default.createElement('canvas', { ref: function ref(canvas) {
        _this5.canvas = canvas;
      }, className: className });
  };

  return ReactPdfJs;
}(_react.Component), _class.defaultProps = {
  page: 1,
  onDocumentComplete: null,
  scale: 1,
  rotate: 0,
  cMapUrl: '../node_modules/pdfjs-dist/cmaps/',
  cMapPacked: false,
  workerSrc: '//cdnjs.cloudflare.com/ajax/libs/pdf.js/2.0.943/pdf.worker.js'
}, _temp2);
exports.default = ReactPdfJs;
ReactPdfJs.propTypes = process.env.NODE_ENV !== "production" ? {
  file: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]).isRequired,
  page: _propTypes2.default.number,
  onDocumentComplete: _propTypes2.default.func,
  scale: _propTypes2.default.number,
  rotate: _propTypes2.default.oneOf([0, 90, 180, 270]),
  cMapUrl: _propTypes2.default.string,
  cMapPacked: _propTypes2.default.bool,
  className: _propTypes2.default.string,
  workerSrc: _propTypes2.default.string
} : {};
module.exports = exports['default'];